
QGIS Application - Bug report #16625

DBManager fails to load raster from dbname-less connection

2017-05-26 12:50 PM - Sandro Santilli

Status: Closed

Priority: High

Assignee: Sandro Santilli

Category: DB Manager

Affected QGIS version:2.18.9 Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 24525

Description

I made a PostGIS connection with no database name, to rely on libpq defaults.

DBManager is capable of using the connection and shows me the available tables, but when attempting to add a raster layer on the map I

get an error about the connection being invalid, specifying that "Cannot open GDAL dataset 'PG:..' You must specify at least a db name".

Note that loading a Vector (GEOMETRY) layer or a simple table works just fine.

I guess DBManager could figure out the dbname from the connection and pass it to GDAL, as a fix.

Related issues:

Related to QGIS Application - Bug report # 10600: db_manager is unable to loa... Closed 2014-06-16

Related to QGIS Application - Bug report # 14436: Failure to connect to postg... Closed 2016-03-07

Associated revisions

Revision 13e39da0 - 2017-05-26 05:52 PM - Sandro Santilli

Ensure "dbname" is set in the uri, once again

Fixes #16625 (ref #10600)

Revision d1e8903c - 2017-05-30 11:14 AM - Sandro Santilli

Ensure "dbname" is set in the uri, once again

Fixes #16625 (ref #10600)

Revision 78c34238 - 2017-06-02 05:31 PM - Sandro Santilli

For GDAL sake extract a dbname from the connection

Works around GDAL limitation reported in:

https://trac.osgeo.org/gdal/ticket/6910

Ref #16625

Ref #16626

Revision 6f42b784 - 2017-06-02 05:38 PM - Sandro Santilli
For GDAL sake extract a dbname from the connection

Works around GDAL limitation reported in:

https://trac.osgeo.org/gdal/ticket/6910

Ref #16625

Closes #16626

Revision 3efee437 - 2017-06-06 05:46 PM - Sandro Santilli

Add test for DBManager's PostGIS connector and plugin

Only enabled when ENABLE_PGTEST is set

Includes test for dbname-less URI and service-only URI

(ref #10600 ref #16625 ref #16626)

The test connects to the `qgis_test` database, or what the

QGIS_PGTEST_DB variable requests (as per tests/README.md)

A raster table is added to the test postgis setup script,

for use by this new test.

History

#1 - 2017-05-26 12:50 PM - Sandro Santilli

- Regression? changed from No to Yes

It looks like this regressed after 2.2.0 (see #10600)

#2 - 2017-05-26 12:53 PM - Giovanni Manghi

- Priority changed from Normal to High

#3 - 2017-05-26 01:29 PM - Sandro Santilli

- Assignee set to Alessandro Pasotti

Alessandro: I think the regression was introduced by commit:212b125a2c2eba93f2c8e3b991ea4be4fdc57623

#4 - 2017-05-26 01:47 PM - Sandro Santilli

- Related to Bug report #10600: db_manager is unable to load rasters from connections with no dbname specified added

#5 - 2017-05-26 01:53 PM - Sandro Santilli

- Assignee changed from Alessandro Pasotti to Sandro Santilli

I'm looking at it, might be an easy fix (None vs. empty-string)

#6 - 2017-05-26 03:19 PM - Sandro Santilli
- Pull Request or Patch supplied changed from No to Yes

Pull requests are ready:

  for 2.18: https://github.com/qgis/QGIS/pull/4635

  for 3.0: https://github.com/qgis/QGIS/issues/4636

#7 - 2017-05-26 05:52 PM - Sandro Santilli

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|13e39da074305a1451b9fd57ce4aedaa8be54121.

#8 - 2017-05-26 06:04 PM - Sandro Santilli

- Status changed from Closed to Open

Reopening as it's pending backport to 2.18 branch (2.18.9 also affected)

#9 - 2017-05-26 06:12 PM - Sandro Santilli

- Related to Bug report #14436: Failure to connect to postgres database defined as service in DB manager added

#10 - 2017-05-30 09:25 AM - Sandro Santilli

- Affected QGIS version changed from 2.18.8 to 2.18.9

#11 - 2017-05-30 11:14 AM - Sandro Santilli

- Status changed from Open to Closed

Applied in changeset commit:qgis|d1e8903cc9800266a307ca1c83dee9d2d244a385.

#12 - 2017-06-02 04:49 PM - Sandro Santilli

As this might strike again in the future, this comment is to mention the main problem is upstream where GDAL requires a dbname to be written in the

datasource:

https://trac.osgeo.org/gdal/ticket/6910
